"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceNullish = void 0;
function replaceNullish(obj, replacer, deep) {
    return Object.entries(obj).reduce((acc, [key, value]) => {
        if (deep) {
            if (Array.isArray(value)) {
                acc[key] = value.map((v) => (typeof v === 'object' ? replaceNullish(v, replacer, deep) : v));
            }
            else if (value instanceof Date) {
                acc[key] = value;
            }
            else if (typeof value === 'object' && value != null) {
                acc[key] = replaceNullish(value, replacer, deep);
            }
            else {
                acc[key] = value ?? replacer;
            }
        }
        else {
            acc[key] = value ?? replacer;
        }
        return acc;
    }, {});
}
exports.replaceNullish = replaceNullish;
